# implementation roadmap

## stages 
- [x] parser
  - [ ] lossless syntax trees (rowan + ungrammar)
    - [ ] formatter (pretty-printer)
- [ ] typechecker
- [x] interpreter
- [ ] virtual machine
- [ ] code generator

## features
- [ ] primitives
  - [x] booleans
  - [x] integers
  - [ ] floating point numbers
  - [ ] text
- [ ] items
  - [x] function definitions
  - [ ] type definitions
- [ ] functions
  - [x] lambdas / closures
  - [ ] generic functions
  - [ ] uniform function call syntax
  - [ ] operators
- [ ] algebraic data types
  - [ ] product types
  - [ ] sum types
    - [ ] variant types
- [ ] pattern matching
- [ ] traits (?)
  - [ ] operator overloading
- [ ] capabilities/effects
